(ns clojure-demo.sitemap
  (:require [clojure.data.xml :as xml]))

(defn pwa-sitemap [domain routes]
  #?(:cljs (xml/emit-str
        {:tag :urlset
         :attrs {#_#_:xmlns "http://www.sitemaps.org/schemas/sitemap/0.9"}
         :content
         (mapv (fn [r]
                 {:tag :url
                  :attrs {}
                  :content [{:tag :loc :attrs {} :content [(str domain r)]}]}
                 ) routes)})
     :clj (xml/indent-str
        {:tag :urlset
         :attrs {:xmlns "http://www.sitemaps.org/schemas/sitemap/0.9"}
         :content
         (mapv (fn [r]
                 {:tag :url
                  :attrs {}
                  :content [{:tag :loc :attrs {} :content [(str domain r)]}]}
                 ) routes)})))

(defmacro spit-pwa-sitemap
  "Generate the sitemap and outut to the provided path"
  {:arglists '([body] [options & body]), :style/indent 0}
  [path domain urls]
  #?(:clj (spit path (pwa-sitemap domain urls))
     :cljs nil))
